//#########################################################################
// File: LCD.H
//
// Ansteuerung einer LCD-Anzeige
// im 8 Bit Daten Mode
//
//#########################################################################
// Last change: 21.04.2003
//#########################################################################
// Compiler: AVR-GCC 3.2
//#########################################################################

#ifndef __LCD_H
#define __LCD_H
//Ausgnge fr die Ansteuerung der LCD-Anzeige
//PORTC AVR an Datenleitungen der LCD-Anzeige

#define NOP() asm volatile ("nop" ::)

#define LCD_RS	5 //LCD Register Select
#define RS_PORT	PORTD
#define LCD_CS	4 //LCD Chip Select
#define CS_PORT	PORTD

#define LCDCS_ON() { sbi(CS_PORT,LCD_CS); }
#define LCDCS_OFF() { cbi(CS_PORT,LCD_CS); }
#define LCDRS_ON() { sbi(RS_PORT,LCD_RS); }
#define LCDRS_OFF() { cbi(RS_PORT,LCD_RS); }

#define Wait() Delay1ms(5);

extern void LCDInit(void);
extern void LCDWriteByte(unsigned char);
extern void LCDWrite(char *);
extern void LCDCls(void);
extern void LCDPos(unsigned char, unsigned char);
extern void ShowHex(unsigned char by);
extern void ShowHexLong(unsigned long l);

#endif
